var toCamelCase = require('to-camel-case');
var Info = require('../Info.js');
var type = function (object) {
	return {}.toString.call(object).match(/\[object (.*?)\]/)[1].toLowerCase();
};
// 不进行rem转换的属性列表
var propertiesThatMustBeStrings = ["font-weight", "fontWeight","flex","z-index","zIndex","opacity","flexBasis","flexShrink","flexGrow"];

// 不可用属性
var inValidStyle = [
    'z-index',
    'user-select',
    'background-image',
    'background-repeat',
    'background-size',
    'background-position',
    'white-space',
    'display',
    "box-shadow",
    "vertical-align"
];

module.exports = function (keys) {
    var me = this;
    var flag = false;
    // me.resourcePath && keys.forEach(function(key,index){
    //     if(inValidStyle.indexOf(key.key) > -1){
    //         flag = true;
    //     }
    // })
	keys.forEach(function (key, index, arr) {
        if(me.sourcePath && inValidStyle.indexOf(key.key) > -1){
            Info.warning(`Unsupported property ${key.key} in Native`);
            Info.info(`File Path：${me.sourcePath}`);
            // Info.normal('====================');
        }
		var value = key.value;
		if (type(key.value) == 'string') {
			if (value == "true" || value == "false") {
				arr[index].value = value == "true";
			} else {
                //用于解决1px问题，不进行rem转换
                if(key.key == 'borderWidth' && key.value <= '1px'){
                    arr[index].value = '1px';
                }else{
                    value = key.value.replace(/px|em/g, '');
                    if (_isNumeric(value) && propertiesThatMustBeStrings.indexOf(arr[index].key) === -1) {
                        arr[index].value = parseFloat(value)*2+'rem';
                    }
                }
			}
		}
		else if (type(key.value) == 'object') {
			for (var prop in key.value) {
				if (type(key.value[prop]) == 'string') {
					value = key.value[prop].replace(/px|em/g, '');
					if (_isNumeric(value)) {
						arr[index].value[prop] = parseInt(value)*2+'rem';
					}
				}
			}
		}
		arr[index].key = toCamelCase(arr[index].key);
	});
};


function _isNumeric(num) {
	return !isNaN(num)
}
